function CCharacter(iX,iY,iIndex,szName){
    var _bDisable = false;
    var _iCurIndex;
    var _iWidth;
    var _iHeight;
    var _oUnselectSprite;
    var _oSprite;
    var _oNameText;
    var _oOver;
    var _oContainer;
    
    var _aCbCompleted;
    var _aCbOwner;
    
    this._init = function(iX,iY,iIndex,szName){
        _iCurIndex = iIndex;
        
        _oContainer = new createjs.Container();
        _oContainer.x = iX;
        _oContainer.y = iY;
        s_oStage.addChild(_oContainer);
        
        var oBmp = s_oSpriteLibrary.getSprite('character_'+iIndex);
        _oSprite = createBitmap(oBmp);
        _oContainer.addChild(_oSprite);
        
        _iWidth = oBmp.width;
        _iHeight = oBmp.height;
        
        _oNameText = new createjs.Text(szName,"37px "+FONT_GAME, "#fff");
        _oNameText.x = oBmp.width/2;
        _oNameText.y = oBmp.height + 30;
        _oNameText.textAlign = "center";
        _oNameText.textBaseline = "alphabetic";
        _oContainer.addChild(_oNameText);
        
        _oUnselectSprite = createBitmap(s_oSpriteLibrary.getSprite('disable_character'));
        _oUnselectSprite.visible = false;
        _oContainer.addChild(_oUnselectSprite);
        
        _oOver = createBitmap(s_oSpriteLibrary.getSprite('character_over'));
        _oOver.visible = false;
        _oContainer.addChild(_oOver);
        
        _aCbCompleted=new Array();
        _aCbOwner =new Array();
        
        
        this._initListener();
    };
    
    this.unload = function(){
       _oSprite.off("mousedown", this.buttonDown);
       _oSprite.off("pressup" , this.buttonRelease); 
       
       if(s_bMobile === false){
           _oSprite.off("rollover",this.mouseOver);
           _oSprite.off("rollout",this.mouseOut);
       }
       
    };
    
    this.enable = function(){
        _bDisable = false;
    };
    
    this.disable = function(){
        _bDisable = true;
        _oOver.visible = false;
    };
    
    this.unselect = function(){
        _bDisable = true;
        
        var matrix = new createjs.ColorMatrix().adjustBrightness(-40);
        _oSprite.filters = [
                 new createjs.ColorMatrixFilter(matrix)
        ];
        _oSprite.cache(0,0,_iWidth,_iHeight);
        
        _oUnselectSprite.visible = true;
    };
    
    this.restore = function(){
        _bDisable = false;
        
        var matrix = new createjs.ColorMatrix().adjustBrightness(0);
        _oSprite.filters = [
                 new createjs.ColorMatrixFilter(matrix)
        ];
        _oSprite.cache(0,0,_iWidth,_iHeight);
        
        _oUnselectSprite.visible = false;
    };
    
    this._initListener = function(){
       _oSprite.on("mousedown", this.buttonDown);
       _oSprite.on("pressup" , this.buttonRelease);  
       
       if(s_bMobile === false){
           _oSprite.on("rollover",this.mouseOver);
           _oSprite.on("rollout",this.mouseOut);
       }
       
       _oSprite.cursor = "pointer";
    };
    
    this.addEventListener = function( iEvent,cbCompleted, cbOwner ){
        _aCbCompleted[iEvent]=cbCompleted;
        _aCbOwner[iEvent] = cbOwner; 
    };
    
    this.buttonRelease = function(){
        if(_bDisable){
            return;
        }
        
        if(DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            createjs.Sound.play("select_character");
        }
        
        if(_aCbCompleted[ON_MOUSE_UP]){
            _aCbCompleted[ON_MOUSE_UP].call(_aCbOwner[ON_MOUSE_UP],_iCurIndex);
        }
    };
    
    this.buttonDown = function(){
        if(_bDisable){
            return;
        }
        
       if(_aCbCompleted[ON_MOUSE_DOWN]){
           _aCbCompleted[ON_MOUSE_DOWN].call(_aCbOwner[ON_MOUSE_DOWN]);
       }
    };
    
    this.mouseOver = function(){
        if(_bDisable){
            return;
        }
        
        _oOver.visible = true;
        
        if(_aCbCompleted[ON_MOUSE_OVER]){
             _aCbCompleted[ON_MOUSE_OVER].call(_aCbOwner[ON_MOUSE_OVER],_oParams);
       }
    };
    
    this.mouseOut = function(){
        if(_bDisable){
            return;
        }
        
        _oOver.visible = false;
        
        if(_aCbCompleted[ON_MOUSE_OUT]){
            _aCbCompleted[ON_MOUSE_OUT].call(_aCbOwner[ON_MOUSE_OUT],_oParams);
       }
    };
    
    this.isUnselectable = function(){
        return _oUnselectSprite.visible;
    };
    
    this._init(iX,iY,iIndex,szName);
}